#!/usr/bin/python

""" Small example filter: make sure the templates of spec files are not stored in the database """

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Copyright 2004 Dries Verachtert

# The rpmforge subversion also contains some templates of spec files and we do not want them in 
# the database. This filter only accepts SpecRepositorySpecFile objects which do not match 
# any of the tempate spec files.

def NoRpmforgeTemplatesFilter(specRepoSpecFile):
    #print "called with obj " + str(specRepoSpecFile)
    fn = specRepoSpecFile.getFileName()
    if fn == "_template.spec" or fn == "_template-fr.spec" or fn == "_perl-template.spec":
        return False
    else:
        return True
