#!/usr/bin/python

""" Script which gets some data from a group of rpms """

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Copyright 2004 Dries Verachtert

# this script gets the versionid, name and distroarchtag from an srpm
# this only works if the versionid is added to the first line of the changelog

import string, re, os
import string


def acceptCommand(aCommand):
    print "test"
    if aCommand.getUserId() != "dries":
        return False
    #if aCommand.getDistroArchTag() != "fc3-i386" and aCommand.getDistroArchTag() != "fc2-i386" and aCommand.getDistroArchTag() != "fc1-i386":
    #    return False
    if aCommand.getSpecRepositoryName() != "rpmforge":
        return False
    if string.find(" " + aCommand.getSpecFileFileName(), 'rrdtool-1.2.spec') > 0:
        return False
    #if string.find(aCommand.getSpecFileShortFileName(),"perl-") < 0:
    #    return False
    authority = aCommand.getAuthority()
    if authority == None:
        print "spec file without authority, ignoring"
        return False
    else:
        if string.find(authority, "axel") > 0:
            return False
    ignoreList = []
    ignoreList.append('gtksourceview.spec')
    ignoreList.append('libgsf')
    ignoreList.append('avidemux.spec')
    ignoreList.append('distcc')
    ignoreList.append('gnomba.spec') # todo fix, it hangs the buildsystem at the moment
    ignoreList.append('boa.spec') # todo fix, it hangs the buildsystem at the moment
    ignoreList.append('e2fsprogs') # system package?
    ignoreList.append('sendmail') # system package
    ignoreList.append('sendmail-old') # ?
    ignoreList.append('arphound') # too much 'void *' stuff in code to write a fix
    ignoreList.append('sagasu-1.0.6') # there's a newer version
    ignoreList.append('kernel-module-') 
    ignoreList.append('perl-Net-SMTP')  # doesn't seem to exist anymore, can't find the source anywhere
    ignoreList.append('xmms-lirc') 
    ignoreList.append('syslinux')
    ignoreList.append('openssh.spec')
    ignoreList.append('amule') # avoid wxgtk problems
    ignoreList.append('apt-dag.spec') # 'apt.spec' seems to be more up to date
    ignoreList.append('bluefish-0.13.spec') # bluefish.spec is newer
    ignoreList.append('easytag.spec') # easytag2.spec is newer
    ignoreList.append('epic4-v1.spec') # epic.spec is newer
    ignoreList.append('epiphany-1.0.spec') # epiphany.spec is newer
    ignoreList.append('fftw-dag.spec') # fftw.spec has higher release, but no idea if i choose the right one for fc4
    ignoreList.append('freetds-0.62.1.spec') # freetds.spec is newer
    ignoreList.append('fslint-1.x.spec') # fslint.spec is newer
    ignoreList.append('gabber-dag.spec') # gabber.spec also exists, are the same
    ignoreList.append('gaim.spec') # avoid replacing the gaim of the distro
    ignoreList.append('gaim-dag.spec') 
    ignoreList.append('galeon-1.2.x.spec') # galeon.spec is newer
    ignoreList.append('gambas-dag.spec') # gambas.spec is newer
    ignoreList.append('gfax-0.5.spec')
    ignoreList.append('gnomeradio-1.1.spec')
    ignoreList.append('gpa-dag.spec')
    ignoreList.append('gpasman-1.2.0.spec')
    ignoreList.append('gq.spec') # unstable?
    ignoreList.append('gramps-0.8.1.spec')
    ignoreList.append('gstreamer') # TODO later
    ignoreList.append('gtkmm2-dag.spec') # newer in gtkmm2.spec
    ignoreList.append('gtkmm2-2.0-dag.spec') 
    ignoreList.append('gtktalog-dag.spec') # gtktalog.spec has higher release
    ignoreList.append('gurlchecker-0.6.x.spec')
    ignoreList.append('gv4l-1.0.spec')
    ignoreList.append('icu-2.4.spec')
    ignoreList.append('libbonobouimm2-1.3.5-dag.spec')
    ignoreList.append('libdvbpsi-dag.spec')
    ignoreList.append('libdvdcss-dag.spec')
    ignoreList.append('libdvdplay-dag.spec')
    ignoreList.append('libdvdread-dag.spec')
    ignoreList.append('libgcrypt.spec')
    ignoreList.append('libgcrypt-1.1.x.spec')
    ignoreList.append('libglademm2-dag.spec')
    ignoreList.append('libnet-1.0.spec')
    ignoreList.append('libnet-1.1.spec')
    ignoreList.append('libsigc++-dag.spec')
    ignoreList.append('lzo-1.04.spec')
    ignoreList.append('mach-dag.spec') # mach.spec is newer
    ignoreList.append('mozilla') # not going to replace os package for now
    ignoreList.append('firefox')
    ignoreList.append('muine-0.4.spec')
    ignoreList.append('nagios-1.1.spec')
    ignoreList.append('nagios-1.2.spec')
    ignoreList.append('nagios-2.0.spec')
    ignoreList.append('openvpn-1.4.spec')
    ignoreList.append('openvpn.spec')
    ignoreList.append('orbitcpp-0.30.spec')
    ignoreList.append('paketto-1.x.spec')
    ignoreList.append('partimage-0.6.spec')
    ignoreList.append('perl-GD-1.x.spec')
    ignoreList.append('perl-RPM-Specfile-dag.spec') # without -dag is newer
    ignoreList.append('revelation-0.3.spec')
    ignoreList.append('rhythmbox-0.6.spec')
    ignoreList.append('rpm2html-1.7.spec')
    ignoreList.append('rrdtool-dag.spec')
    ignoreList.append('rrdtool.spec')
    ignoreList.append('rsync') # system package, not yet updated
    ignoreList.append('snackam-fdw.spec')
    ignoreList.append('straw-0.21.1.spec')
    ignoreList.append('subtitleripper-dag.spec')
    ignoreList.append('subversion')
    ignoreList.append('swfdec-0.2.2.spec')
    ignoreList.append('sylpheed-claws-gtk1.spec')
    ignoreList.append('tcpreplay-1.3.spec')
    ignoreList.append('texmaker-1.0.1.spec')
    ignoreList.append('xvidcore-dev.spec')
    ignoreList.append('yum.spec')
    ignoreList.append('yum-1.0.spec')
    
    
    print "ignorelist ok"
    for i in ignoreList:
        #print "going to check for " + str(i)
        if string.find(" " + aCommand.getSpecFileFileName(), i) > 0:
            return False
    # also check the architecture
    arch = aCommand.getArch()
    print "arch is: " + str(arch)
    # get the file so we can search for 'ExclusiveArch' stuff
    fullpath = aCommand.getSpecRepositorySpecFile().getFullPath()
    contents = __getContents(fullpath)
    mo = re.search(re.compile('^ExclusiveArch:(.*)\n',re.MULTILINE), contents)
    if mo != None:
        # an ExclusiveArch is found
        exclusiveArchs = mo.group(1)
        if string.find(" " + exclusiveArchs, arch) > 0:
            # ok
            print "arch " + str(arch) + " is included in the exclusivearchs " + str(exclusiveArchs)
        else:
            # not ok
            print "arch" + str(arch) + " is not included in the list of exclusiveArchs " + str(exclusiveArchs)
            return False
    mo = re.search(re.compile('^# Tag: test', re.MULTILINE), contents)
    if mo != None:
        return False
    return True

def __getContents(path):
    fd = open(path, "r")
    contents = ""
    line = fd.readline()
    while line != "":
        contents = contents + line
        line = fd.readline()
    fd.close()
    return contents
    